# Copyright (c) 2014 Dave Love, Liverpool University
# The licence for this file is as for the package itself.

%{?scl:%scl_package vite}
%{!?scl:%global pkg_name %{name}}

#%%global commit 4274861a1acc2b843d1d713b165c0afa7d21e66d
%global commit ad10e0adea68be1f46cce82497a343385145a265
%global shortcommit %(c=%{commit}; echo ${c:0:7})

%if 0%{?el6}%{?el7}
%global dts devtoolset-9-
%endif

Name:		%{?scl_prefix}vite
Version:	1.2.git%shortcommit
Release:	5%{?scl:.scl1}%{?dist}
Summary:	Efficient visual trace explorer
License:	CeCILL
URL:		http://vite.gforge.inria.fr/
Source0:	https://gitlab.inria.fr/solverstack/vite/-/archive/%commit/vite-%shortcommit.tar.gz
# Un-packaged LaTeX
Source1:	lettrine.sty
Source2:	minifp.sty
Patch1:		vite-assert.patch
BuildRequires:	cmake3 zlib-devel %{?dts}gcc-c++
BuildRequires:	glm-devel glew-devel %{?scl_prefix}otf2-devel >= 2
# Missing UiTools, Widgets
#BuildRequires:	qt5-qtbase-devel qt5-qttools-devel
BuildRequires:	qt-devel
BuildRequires:	tex(latex) tex(supertabular.sty) tex(longtable.sty)
BuildRequires:	tex(multirow.sty) /usr/bin/dvipdf

%{?scl:Requires: %scl_runtime}

%{?filter_setup:
%filter_from_requires /libopen-trace-format\.so.*/d
%filter_setup
}


%description
ViTE is a powerful portable and open source profiling tool to
visualize the behaviour of parallel applications.  Thanks to its
scalable design, ViTE helps programmers to efficiently analyze the
performance of potentially large applications.

ViTE currently enables the visualisation of traces using the Pajé
format or OTF1 and has various functionalities such as exporting a
view in an SVG format to integrate the results easily in a report, or
viewing statistics.

%package doc
Summary:	Documentation for %name
BuildArch:	noarch

%description doc
Documentation for %name.


%prep
%setup -q -n vite-%commit
chmod 0644 src/render/Minimap.*pp
%patch1 -p1
cp %SOURCE1 %SOURCE2 .


%build
%{?dts:. /opt/rh/devtoolset-9/enable}
# Plugins need Qt stuff we don't seem to have in el7
#export LDFLAGS="-Wl,-rpath,$MPI_LIB"
export CXXFLAGS='-std=gnu++14' # -I%_includedir/qt5'
pushd externals/otf
%configure
%make_build
popd
# per Debian
%cmake3 . -DVITE_ENABLE_OTF2=ON -DVITE_ENABLE_OTF=OFF -DVITE_ENABLE_MT_PARSERS=ON -DUSE_QT5=OFF
%make_build
TEXINPUTS=$(pwd): make -C docs/user_manual
make -C docs/technical_manual


%install
%make_install
install -m 644 -D vite.1 $RPM_BUILD_ROOT%_mandir/man1/vite.1


%check
# Fixme: How, and is it useful?


%files
%license licence/*
%_bindir/vite
%_mandir/man1/vite.1*

%files doc
%license licence/*
%doc docs/*manual/*.pdf


%changelog
* Sat Aug 22 2020 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-5:.scl1}%{?dist}
- New version

* Tue Jul  7 2020 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-4:.scl1}%{?dist}
- New version
- Maybe use dts9, not 7

* Fri Nov 15 2019 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-4:.scl1}
- New development version, built against otf2

* Thu Dec 20 2018 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-3:.scl1}
- Don't use OTF (not in recent openmpi), just OTF2

* Sat Dec 15 2018 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-2.scl1
- New version

* Thu Nov 29 2018 Dave Love <loveshack@fedoraproject.org> - 1.2.git%(c=%{commit}; echo ${c:0:7})-1
- New version (supporting OTF2)

* Fri Nov 21 2014 Dave Love <d.love@liverpool.ac.uk> - 1.2.1430svn-1
- Initial packaging
